#include <iostream>;
#include <iomanip>;
#include <vector>;
#include <map>;
#include <stack>;
#include <cstdio>
#include <cstring>;
#include <algorithm>;
using namespace std;
int n,q,l,d,a[200005],rezultat;
int main(){
    cin>>n>>q;
    for(int i=1;i<=n;i++)scanf("%d",&a[i]);
    for(int i=1;i<=q;i++){
        scanf("%d %d",&l,&d);
        rezultat=a[l];
        for(int k=l+1;k<=d;k++){
            rezultat=(rezultat&a[k]);
        }
        printf("%d\n",rezultat);
    }


return 0;
}